#!/bin/bash

set -e

for zone in \
  {{ (proxy.internal.network | ipaddr('revdns'))[2:-1] }} \
  {{ (k8s.external_service_ip | ipaddr('revdns'))[2:-1] }}
do

#kill trailing .
zone=${zone%\.}

cat <<EOF > dynamic/$zone.zone
\$TTL  86400
@   IN    SOA   ns.portal.{{ domain }}. root.$zone (
    1         ; serial
    604800    ; refresh
    86400     ; retry
    2419200   ; expire
    86400 )   ; minimum
;
@     IN      NS      ns.portal.{{ domain }}.
{{ proxy.internal.virtual_ip | ipaddr('revdns') }} PTR api.portal.{{ domain }}.
{{ proxy.internal.virtual_ip | ipaddr('revdns') }} PTR www.portal.{{ domain }}.
{{ proxy.0.internal.ip.addr | ipaddr('revdns') }} PTR ns0.portal.{{ domain }}.
{{ proxy.1.internal.ip.addr | ipaddr('revdns') }} PTR ns1.portal.{{ domain }}.
EOF

dnssec-keygen -r /dev/urandom -a NSEC3RSASHA1 -b 2048 -n ZONE $zone
dnssec-keygen -r /dev/urandom -f KSK -a NSEC3RSASHA1 -b 4096 -n ZONE $zone

for key in `ls K$zone*.key`
do
  echo "\$INCLUDE $key">> dynamic/$zone.zone
done

dnssec-signzone \
  -r /dev/urandom \
  -A -3 \
  $(head -c 1000 /dev/urandom | sha1sum | cut -b 1-16) \
  -N INCREMENT -o $zone -t dynamic/$zone.zone

done #-------------------------------------------------------------------------

for zone in {{ (proxy.external.network | ipaddr('revdns'))[2:-1] }}
do

cat <<EOF > dynamic/$zone.zone
\$TTL  86400
@   IN    SOA   ns.{{ domain }}. root.$zone (
    1         ; serial
    604800    ; refresh
    86400     ; retry
    2419200   ; expire
    86400 )   ; minimum
;
@     IN      NS      ns.{{ domain }}.
{{ proxy.external.virtual_ip | ipaddr('revdns') }} PTR portal.{{ domain }}.
{{ proxy.external.virtual_ip | ipaddr('revdns') }} PTR api.portal.{{ domain }}.
{{ proxy.external.virtual_ip | ipaddr('revdns') }} PTR www.portal.{{ domain }}.
{{ proxy.0.external.ip.addr | ipaddr('revdns') }} PTR ns0.portal.{{ domain }}.
{{ proxy.1.external.ip.addr | ipaddr('revdns') }} PTR ns1.portal.{{ domain }}.
EOF

dnssec-keygen -r /dev/urandom -a NSEC3RSASHA1 -b 2048 -n ZONE $zone
dnssec-keygen -r /dev/urandom -f KSK -a NSEC3RSASHA1 -b 4096 -n ZONE $zone

for key in `ls K$zone*.key`
do
  echo "\$INCLUDE $key">> dynamic/$zone.zone
done

dnssec-signzone \
  -r /dev/urandom \
  -A -3 \
  $(head -c 1000 /dev/urandom | sha1sum | cut -b 1-16) \
  -N INCREMENT -o $zone -t dynamic/$zone.zone

done #-------------------------------------------------------------------------
